'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _contract_jsons = require('../contract_jsons');

var _contract_jsons2 = _interopRequireDefault(_contract_jsons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Computed as:
 * floor((Total AMB supply) * 2% / (blocks/year))
 */
var DEFAULT_BLOCK_REWARD = '1146237435108134836'; /*
                                                  Copyright: Ambrosus Technologies GmbH
                                                  Email: tech@ambrosus.com
                                                  
                                                  This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.
                                                  
                                                  This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
                                                  */

var DeployActions = function () {
  function DeployActions(deployer) {
    (0, _classCallCheck3.default)(this, DeployActions);

    this.deployer = deployer;
    this.sender = this.deployer.sender;
  }

  (0, _createClass3.default)(DeployActions, [{
    key: 'deployGenesis',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(initialValidators) {
        var baseReward = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT_BLOCK_REWARD;
        var headJson, validatorSetJson, blockRewardsJson, head, validatorSet, blockRewards;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                headJson = _contract_jsons2.default.head, validatorSetJson = _contract_jsons2.default.validatorSet, blockRewardsJson = _contract_jsons2.default.blockRewards;
                _context.next = 3;
                return this.deployer.deployContract(headJson, [this.sender], {});

              case 3:
                head = _context.sent;
                _context.next = 6;
                return this.deployer.deployContract(validatorSetJson, [this.sender, initialValidators, this.sender], {});

              case 6:
                validatorSet = _context.sent;
                _context.next = 9;
                return this.deployer.deployContract(blockRewardsJson, [this.sender, baseReward, this.sender], {});

              case 9:
                blockRewards = _context.sent;
                return _context.abrupt('return', { head: head, validatorSet: validatorSet, blockRewards: blockRewards });

              case 11:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function deployGenesis(_x) {
        return _ref.apply(this, arguments);
      }

      return deployGenesis;
    }()
  }, {
    key: 'validateGenesisAddresses',
    value: function validateGenesisAddresses(addresses) {
      var isAddress = function isAddress(address) {
        return (/0x[a-f0-9]{40}/i.exec(address)
        );
      };
      ['head', 'validatorSet', 'blockRewards'].forEach(function (contractName) {
        if (!isAddress(addresses[contractName])) {
          throw new Error(contractName + ' address ' + addresses[contractName] + ' is not a valid Ethereum address');
        }
      });
    }
  }, {
    key: 'deployAll',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(head, validatorSet, blockRewards) {
        var turbo = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
        var overrides, contractsToDeploy;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this.validateGenesisAddresses({ head: head, validatorSet: validatorSet, blockRewards: blockRewards });
                overrides = turbo ? _contract_jsons.contractSuperSpeedJsons : {};
                contractsToDeploy = (0, _extends3.default)({}, _contract_jsons2.default, overrides);
                return _context2.abrupt('return', this.deployer.deploy(contractsToDeploy, { head: head, validatorSet: validatorSet, blockRewards: blockRewards }));

              case 4:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function deployAll(_x3, _x4, _x5) {
        return _ref2.apply(this, arguments);
      }

      return deployAll;
    }()
  }]);
  return DeployActions;
}();

exports.default = DeployActions;