'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OnboardActions = function () {
  function OnboardActions(kycWhitelistWrapper, rolesWrapper) {
    (0, _classCallCheck3.default)(this, OnboardActions);

    this.kycWhitelistWrapper = kycWhitelistWrapper;
    this.rolesWrapper = rolesWrapper;
  }

  (0, _createClass3.default)(OnboardActions, [{
    key: 'onboardAsAtlas',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(address, stakeAmount, url) {
        var roles;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.validateWhitelistedForRole(address, _constants.ATLAS);

              case 2:
                _context.next = 4;
                return this.validateStakeDepositAmount(address, stakeAmount);

              case 4:
                roles = this.rolesWrapper;
                _context.next = 7;
                return roles.onboardAsAtlas(address, stakeAmount, url);

              case 7:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function onboardAsAtlas(_x, _x2, _x3) {
        return _ref.apply(this, arguments);
      }

      return onboardAsAtlas;
    }()
  }, {
    key: 'onboardAsHermes',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(address, url) {
        var roles;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.validateWhitelistedForRole(address, _constants.HERMES);

              case 2:
                roles = this.rolesWrapper;
                _context2.next = 5;
                return roles.onboardAsHermes(address, url);

              case 5:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function onboardAsHermes(_x4, _x5) {
        return _ref2.apply(this, arguments);
      }

      return onboardAsHermes;
    }()
  }, {
    key: 'onboardAsApollo',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(address, depositAmount) {
        var roles;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.validateWhitelistedForRole(address, _constants.APOLLO);

              case 2:
                _context3.next = 4;
                return this.validateStakeDepositAmount(address, depositAmount);

              case 4:
                roles = this.rolesWrapper;
                _context3.next = 7;
                return roles.onboardAsApollo(address, depositAmount);

              case 7:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function onboardAsApollo(_x6, _x7) {
        return _ref3.apply(this, arguments);
      }

      return onboardAsApollo;
    }()
  }, {
    key: 'getOnboardedRole',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(address) {
        var roles;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                roles = this.rolesWrapper;
                _context4.next = 3;
                return roles.onboardedRole(address);

              case 3:
                _context4.t0 = _context4.sent;
                _context4.next = 6;
                return roles.nodeUrl(address);

              case 6:
                _context4.t1 = _context4.sent;
                return _context4.abrupt('return', {
                  role: _context4.t0,
                  url: _context4.t1
                });

              case 8:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function getOnboardedRole(_x8) {
        return _ref4.apply(this, arguments);
      }

      return getOnboardedRole;
    }()
  }, {
    key: 'validateWhitelistedForRole',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(address, role) {
        var kyc;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                kyc = this.kycWhitelistWrapper;
                _context5.next = 3;
                return kyc.hasRoleAssigned(address, role);

              case 3:
                if (_context5.sent) {
                  _context5.next = 5;
                  break;
                }

                throw new Error('Address ' + address + ' is not white-listed for the ' + _constants.ROLE_REVERSE_CODES[role] + ' role.');

              case 5:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function validateWhitelistedForRole(_x9, _x10) {
        return _ref5.apply(this, arguments);
      }

      return validateWhitelistedForRole;
    }()
  }, {
    key: 'validateStakeDepositAmount',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(address, amount) {
        var kyc, requiredAmount;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                kyc = this.kycWhitelistWrapper;
                _context6.next = 3;
                return kyc.getRequiredDeposit(address);

              case 3:
                requiredAmount = _context6.sent;

                if (!(requiredAmount !== amount)) {
                  _context6.next = 6;
                  break;
                }

                throw new Error('Address ' + address + ' requires a deposit of ' + requiredAmount + ' but ' + amount + ' provided.');

              case 6:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function validateStakeDepositAmount(_x11, _x12) {
        return _ref6.apply(this, arguments);
      }

      return validateStakeDepositAmount;
    }()
  }]);
  return OnboardActions;
}(); /*
     Copyright: Ambrosus Technologies GmbH
     Email: tech@ambrosus.com
     
     This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.
     
     This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
     */

exports.default = OnboardActions;