"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright: Ambrosus Technologies GmbH
Email: tech@ambrosus.com

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.

This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
*/

var UploadActions = function () {
  function UploadActions(uploadsWrapper, feesWrapper, shelteringWrapper, blockchainStateWrapper) {
    (0, _classCallCheck3.default)(this, UploadActions);

    this.uploadsWrapper = uploadsWrapper;
    this.feesWrapper = feesWrapper;
    this.shelteringWrapper = shelteringWrapper;
    this.blockchainStateWrapper = blockchainStateWrapper;
  }

  (0, _createClass3.default)(UploadActions, [{
    key: "uploadBundle",
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(bundleId, storagePeriods) {
        var uploads, fees, value, _ref2, blockNumber, transactionHash, timestamp;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                uploads = this.uploadsWrapper, fees = this.feesWrapper;
                _context.next = 3;
                return fees.feeForUpload(storagePeriods);

              case 3:
                value = _context.sent;
                _context.next = 6;
                return uploads.registerBundle(bundleId, value, storagePeriods);

              case 6:
                _ref2 = _context.sent;
                blockNumber = _ref2.blockNumber;
                transactionHash = _ref2.transactionHash;
                _context.next = 11;
                return this.blockchainStateWrapper.getBlockTimestamp(blockNumber);

              case 11:
                timestamp = _context.sent;
                return _context.abrupt("return", { blockNumber: blockNumber, transactionHash: transactionHash, timestamp: timestamp });

              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function uploadBundle(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return uploadBundle;
    }()
  }, {
    key: "getBundleUploadData",
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(bundleId) {
        var uploadBlock, timestamp, _ref4, transactionHash;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.shelteringWrapper.getBundleUploadBlockNumber(bundleId);

              case 2:
                uploadBlock = _context2.sent;

                if (uploadBlock) {
                  _context2.next = 5;
                  break;
                }

                return _context2.abrupt("return", null);

              case 5:
                _context2.next = 7;
                return this.blockchainStateWrapper.getBlockTimestamp(uploadBlock);

              case 7:
                timestamp = _context2.sent;
                _context2.next = 10;
                return this.uploadsWrapper.getUploadData(bundleId, uploadBlock);

              case 10:
                _ref4 = _context2.sent;
                transactionHash = _ref4.transactionHash;
                return _context2.abrupt("return", { blockNumber: uploadBlock, transactionHash: transactionHash, timestamp: timestamp });

              case 13:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getBundleUploadData(_x3) {
        return _ref3.apply(this, arguments);
      }

      return getBundleUploadData;
    }()
  }]);
  return UploadActions;
}();

exports.default = UploadActions;