'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _web3_tools = require('../utils/web3_tools');

var _whitelist = require('./whitelist');

var _whitelist2 = _interopRequireDefault(_whitelist);

var _deploy = require('./deploy');

var _deploy2 = _interopRequireDefault(_deploy);

var _onboard = require('./onboard');

var _onboard2 = _interopRequireDefault(_onboard);

var _task_list = require('./base/task_list');

var _task_list2 = _interopRequireDefault(_task_list);

var _upload = require('./upload');

var _upload2 = _interopRequireDefault(_upload);

var _head_wrapper = require('../wrappers/head_wrapper');

var _head_wrapper2 = _interopRequireDefault(_head_wrapper);

var _roles_wrapper = require('../wrappers/roles_wrapper');

var _roles_wrapper2 = _interopRequireDefault(_roles_wrapper);

var _uploads_wrapper = require('../wrappers/uploads_wrapper');

var _uploads_wrapper2 = _interopRequireDefault(_uploads_wrapper);

var _fees_wrapper = require('../wrappers/fees_wrapper');

var _fees_wrapper2 = _interopRequireDefault(_fees_wrapper);

var _kyc_whitelist_wrapper = require('../wrappers/kyc_whitelist_wrapper');

var _kyc_whitelist_wrapper2 = _interopRequireDefault(_kyc_whitelist_wrapper);

var _whitelist_actions = require('../actions/whitelist_actions');

var _whitelist_actions2 = _interopRequireDefault(_whitelist_actions);

var _onboard_actions = require('../actions/onboard_actions');

var _onboard_actions2 = _interopRequireDefault(_onboard_actions);

var _upload_actions = require('../actions/upload_actions');

var _upload_actions2 = _interopRequireDefault(_upload_actions);

var _config = require('../../config/config');

var _config2 = _interopRequireDefault(_config);

var _sheltering_wrapper = require('../wrappers/sheltering_wrapper');

var _sheltering_wrapper2 = _interopRequireDefault(_sheltering_wrapper);

var _node_service = require('./node_service');

var _node_service2 = _interopRequireDefault(_node_service);

var _node_service3 = require('../actions/node_service');

var _node_service4 = _interopRequireDefault(_node_service3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright: Ambrosus Technologies GmbH
Email: tech@ambrosus.com

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.

This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
*/

var runTask = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var web3, nodeAddress, headWrapper, rolesWrapper, uploadsWrapper, feesWrapper, kycWhitelistWrapper, shelteringWrapper, whitelistActions, onboardActions, uploadActions, nodeServiceActions, list, args;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _web3_tools.createWeb3)();

          case 2:
            web3 = _context.sent;
            nodeAddress = web3.eth.accounts.privateKeyToAccount(_config2.default.nodePrivateKey).address;
            headWrapper = new _head_wrapper2.default(_config2.default.headContractAddress, web3, nodeAddress);
            rolesWrapper = new _roles_wrapper2.default(headWrapper, web3, nodeAddress);
            uploadsWrapper = new _uploads_wrapper2.default(headWrapper, web3, nodeAddress);
            feesWrapper = new _fees_wrapper2.default(headWrapper, web3, nodeAddress);
            kycWhitelistWrapper = new _kyc_whitelist_wrapper2.default(headWrapper, web3, nodeAddress);
            shelteringWrapper = new _sheltering_wrapper2.default(headWrapper, web3, nodeAddress);
            whitelistActions = new _whitelist_actions2.default(kycWhitelistWrapper);
            onboardActions = new _onboard_actions2.default(kycWhitelistWrapper, rolesWrapper);
            uploadActions = new _upload_actions2.default(uploadsWrapper, feesWrapper, shelteringWrapper);
            nodeServiceActions = new _node_service4.default(rolesWrapper);
            list = new _task_list2.default();
            args = process.argv.slice(2);

            list.add('deploy', new _deploy2.default(web3, nodeAddress));
            list.add('onboard', new _onboard2.default(web3, nodeAddress, onboardActions));
            list.add('whitelist', new _whitelist2.default(web3, whitelistActions, onboardActions));
            list.add('upload', new _upload2.default(uploadActions));
            list.add('nodeService', new _node_service2.default(nodeAddress, nodeServiceActions));

            _context.next = 23;
            return list.run(args[0], args.slice(1));

          case 23:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function runTask() {
    return _ref.apply(this, arguments);
  };
}();

runTask().catch(function (error) {
  console.error(error);
  process.exit(1);
});