'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.listDirectory = exports.checkFileExists = exports.readFile = exports.writeFile = undefined;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var writeFile = function writeFile(path, data) {
  return new Promise(function (resolve, reject) {
    _fs2.default.writeFile(path, data, function (err) {
      if (err) {
        reject(err);
      } else {
        resolve(data);
      }
    });
  });
}; /*
   Copyright: Ambrosus Technologies GmbH
   Email: tech@ambrosus.com
   
   This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.
   
   This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
   */

var readFile = function readFile(path) {
  return new Promise(function (resolve, reject) {
    _fs2.default.readFile(path, function (err, data) {
      if (err) {
        reject(err);
      } else {
        resolve(data);
      }
    });
  });
};

var checkFileExists = function checkFileExists(path) {
  return new Promise(function (resolve) {
    _fs2.default.access(path, function (err) {
      resolve(!err);
    });
  });
};

var listDirectory = function listDirectory(path) {
  return new Promise(function (resolve, reject) {
    _fs2.default.readdir(path, function (err, files) {
      if (err) {
        reject(err);
      } else {
        resolve(files);
      }
    });
  });
};

exports.writeFile = writeFile;
exports.readFile = readFile;
exports.checkFileExists = checkFileExists;
exports.listDirectory = listDirectory;