'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _constants = require('../constants');

var _contract_wrapper = require('./contract_wrapper');

var _contract_wrapper2 = _interopRequireDefault(_contract_wrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright: Ambrosus Technologies GmbH
Email: tech@ambrosus.com

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.

This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
*/

var ChallengesWrapper = function (_ContractWrapper) {
  (0, _inherits3.default)(ChallengesWrapper, _ContractWrapper);

  function ChallengesWrapper() {
    (0, _classCallCheck3.default)(this, ChallengesWrapper);
    return (0, _possibleConstructorReturn3.default)(this, (ChallengesWrapper.__proto__ || Object.getPrototypeOf(ChallengesWrapper)).apply(this, arguments));
  }

  (0, _createClass3.default)(ChallengesWrapper, [{
    key: 'earliestMeaningfulBlock',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(challengeDuration) {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.t0 = Math;
                _context.next = 3;
                return this.web3.eth.getBlockNumber();

              case 3:
                _context.t1 = _context.sent;
                _context.t2 = Math.ceil(challengeDuration / _constants.MIN_BLOCK_TIME);
                _context.t3 = _context.t1 - _context.t2;
                return _context.abrupt('return', _context.t0.max.call(_context.t0, 0, _context.t3));

              case 7:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function earliestMeaningfulBlock(_x) {
        return _ref.apply(this, arguments);
      }

      return earliestMeaningfulBlock;
    }()
  }, {
    key: 'challenges',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(fromBlock) {
        var contract;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.contract();

              case 2:
                contract = _context2.sent;
                return _context2.abrupt('return', contract.getPastEvents('ChallengeCreated', { fromBlock: fromBlock }));

              case 4:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function challenges(_x2) {
        return _ref2.apply(this, arguments);
      }

      return challenges;
    }()
  }, {
    key: 'resolvedChallenges',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(fromBlock) {
        var contract;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.contract();

              case 2:
                contract = _context3.sent;
                return _context3.abrupt('return', contract.getPastEvents('ChallengeResolved', { fromBlock: fromBlock }));

              case 4:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function resolvedChallenges(_x3) {
        return _ref3.apply(this, arguments);
      }

      return resolvedChallenges;
    }()
  }, {
    key: 'timedOutChallenges',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(fromBlock) {
        var contract;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.contract();

              case 2:
                contract = _context4.sent;
                return _context4.abrupt('return', contract.getPastEvents('ChallengeTimeout', { fromBlock: fromBlock }));

              case 4:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function timedOutChallenges(_x4) {
        return _ref4.apply(this, arguments);
      }

      return timedOutChallenges;
    }()
  }, {
    key: 'resolve',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(challengeId) {
        var contract;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this.contract();

              case 2:
                contract = _context5.sent;
                return _context5.abrupt('return', this.processTransaction(contract.methods.resolve(challengeId)));

              case 4:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function resolve(_x5) {
        return _ref5.apply(this, arguments);
      }

      return resolve;
    }()
  }, {
    key: 'canResolve',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(challengeId) {
        var contract;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this.contract();

              case 2:
                contract = _context6.sent;
                return _context6.abrupt('return', contract.methods.canResolve(this.defaultAddress, challengeId).call());

              case 4:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function canResolve(_x6) {
        return _ref6.apply(this, arguments);
      }

      return canResolve;
    }()
  }, {
    key: 'isInProgress',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(challengeId) {
        var contract;
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this.contract();

              case 2:
                contract = _context7.sent;
                return _context7.abrupt('return', contract.methods.challengeIsInProgress(challengeId).call());

              case 4:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function isInProgress(_x7) {
        return _ref7.apply(this, arguments);
      }

      return isInProgress;
    }()
  }, {
    key: 'getContractName',
    get: function get() {
      return 'challenges';
    }
  }]);
  return ChallengesWrapper;
}(_contract_wrapper2.default);

exports.default = ChallengesWrapper;