'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _contract_wrapper = require('./contract_wrapper');

var _contract_wrapper2 = _interopRequireDefault(_contract_wrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var UploadsWrapper = function (_ContractWrapper) {
  (0, _inherits3.default)(UploadsWrapper, _ContractWrapper);

  function UploadsWrapper() {
    (0, _classCallCheck3.default)(this, UploadsWrapper);
    return (0, _possibleConstructorReturn3.default)(this, (UploadsWrapper.__proto__ || Object.getPrototypeOf(UploadsWrapper)).apply(this, arguments));
  }

  (0, _createClass3.default)(UploadsWrapper, [{
    key: 'registerBundle',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(bundleId, fee, storagePeriods) {
        var contract, _ref2, blockNumber, transactionHash;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.contract();

              case 2:
                contract = _context.sent;
                _context.next = 5;
                return contract.methods.registerBundle(bundleId, storagePeriods).send({ from: this.defaultAddress, value: fee });

              case 5:
                _ref2 = _context.sent;
                blockNumber = _ref2.blockNumber;
                transactionHash = _ref2.transactionHash;
                return _context.abrupt('return', { blockNumber: blockNumber, transactionHash: transactionHash });

              case 9:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function registerBundle(_x, _x2, _x3) {
        return _ref.apply(this, arguments);
      }

      return registerBundle;
    }()

    /**
     * @returns {Object} bundle blockchain data
     * @property {number} blockNumber block number when the bundle was uploaded
     * @property {string} transactionHash bundle upload transaction hash
     */

  }, {
    key: 'getUploadData',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(bundleId, blockNumber) {
        var contract, bundleUploadEvents, _bundleUploadEvents, transactionHash;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.contract();

              case 2:
                contract = _context2.sent;
                _context2.next = 5;
                return contract.getPastEvents('BundleUploaded', { fromBlock: blockNumber, toBlock: blockNumber });

              case 5:
                _context2.t0 = function (_ref4) {
                  var returnValues = _ref4.returnValues;
                  return returnValues.bundleId === bundleId;
                };

                bundleUploadEvents = _context2.sent.filter(_context2.t0);

                if (!(bundleUploadEvents.length === 0)) {
                  _context2.next = 9;
                  break;
                }

                return _context2.abrupt('return', null);

              case 9:
                _bundleUploadEvents = (0, _slicedToArray3.default)(bundleUploadEvents, 1), transactionHash = _bundleUploadEvents[0].transactionHash;
                return _context2.abrupt('return', {
                  transactionHash: transactionHash,
                  blockNumber: blockNumber
                });

              case 11:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getUploadData(_x4, _x5) {
        return _ref3.apply(this, arguments);
      }

      return getUploadData;
    }()
  }, {
    key: 'getContractName',
    get: function get() {
      return 'uploads';
    }
  }]);
  return UploadsWrapper;
}(_contract_wrapper2.default); /*
                               Copyright: Ambrosus Technologies GmbH
                               Email: tech@ambrosus.com
                               
                               This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.
                               
                               This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
                               */

exports.default = UploadsWrapper;